import { ArrayedOrStringType, ArrayedType, Cycle, Ordinal } from '../nominal';
declare const slice: <ArrayType extends ArrayedOrStringType>(array: ArrayType, initial: Ordinal<ArrayType>, terminal?: Ordinal<ArrayType>) => ArrayType;
declare const cycleSlice: <ElementType>(cycle: Cycle<ElementType>, initial: Ordinal<Cycle<ElementType>>, terminal?: Ordinal<Cycle<ElementType>>) => ElementType[];
declare const forEach: <ElementType, ArrayType extends ArrayedType<ElementType> = ElementType[]>(array: ArrayType, callback: (element: ElementType, index: Ordinal<ArrayType>, self: ArrayType) => void) => void;
declare const map: <MappedElementType, MappedArrayType extends ArrayedType<MappedElementType>, ElementType, ArrayType extends ArrayedType<ElementType> = ElementType[]>(array: ArrayType, callback: (element: ElementType, index: Ordinal<ArrayType>, self: ArrayType) => MappedElementType) => MappedArrayType;
declare const reduce: <ReducedType, ElementType, ArrayType extends ArrayedType<ElementType> = ElementType[]>(array: ElementType[], callback: (accumulator: ReducedType, element: ElementType, index: Ordinal<ArrayType>, self: ArrayType) => ReducedType, accumulator: Partial<ReducedType>) => ReducedType;
declare const filter: <ElementType, ArrayType extends ArrayedType<ElementType> = ElementType[]>(array: ArrayType, callback: (element: ElementType, index: Ordinal<ArrayType>, self: ArrayType) => boolean) => ArrayType;
declare const every: <ElementType, ArrayType extends ArrayedType<ElementType> = ElementType[]>(array: ArrayType, callback: (element: ElementType, index: Ordinal<ArrayType>, self: ArrayType) => boolean) => boolean;
declare const findIndex: <ElementType, ArrayType extends ArrayedType<ElementType> = ElementType[]>(array: ArrayType, callback: (element: ElementType, index: Ordinal<ArrayType>, self: ArrayType) => boolean) => Ordinal<ArrayType>;
export { slice, cycleSlice, forEach, map, reduce, filter, every, findIndex, };
