import { Map } from 'immutable';
interface TypedMap<ObjectType extends Object> extends Map<keyof ObjectType, ObjectType[keyof ObjectType]> {
    get<KeyType extends keyof ObjectType>(key: KeyType, notSetValue?: ObjectType[KeyType]): ObjectType[KeyType];
    set<KeyType extends keyof ObjectType>(key: KeyType, value: ObjectType[KeyType]): this;
    toJS(): ObjectType & {
        [key: string]: unknown;
    };
}
declare const typedMap: <ObjectType extends Object>(object: ObjectType) => TypedMap<ObjectType>;
declare const entries: <KeyType extends string, ValueType>(object: Partial<{
    [Index in KeyType]: ValueType;
}>) => Array<[KeyType, ValueType]>;
declare const keys: <KeyType extends string, ValueType>(object: {
    [Index in KeyType]: ValueType;
}) => KeyType[];
export { entries, keys, typedMap, TypedMap, };
