declare type ObjectDifference<ObjectType extends ObjectTypeWithPropertiesToSubtract, ObjectTypeWithPropertiesToSubtract> = Omit<ObjectType, keyof ObjectTypeWithPropertiesToSubtract>;
declare type KeyMap<ObjectWithKeys extends ObjectOf<unknown>, NewValueType> = {
    [Index in keyof ObjectWithKeys]: NewValueType;
};
interface ObjectOf<ValueType> {
    [index: string]: ValueType;
}
declare type Maybe<Type> = Type | undefined;
declare type Just<Type, MaybeType extends Maybe<Type>> = Type;
declare type ArrayOfLength<Length extends Number, NumericType = number> = [NumericType, ...NumericType[]] & {
    length: Length;
};
declare type NonPartial<PartialType> = {
    [Index in keyof PartialType]-?: PartialType[Index];
};
declare type Difference<Type, TypeWithSubtypesToRemove> = Type extends TypeWithSubtypesToRemove ? never : Type;
declare type Thunk<Type = void> = () => Type;
declare type AsyncThunk<Type = void> = () => Promise<Type>;
export { ObjectDifference, KeyMap, ObjectOf, Maybe, ArrayOfLength, NonPartial, Just, Difference, Thunk, AsyncThunk, };
