import { ObjectOf } from '../code';
import { Amplitude, Delta, Frequency, Hz, Interval, Meters, Ms, NormalScalar, Point, Scalar, Space, Time } from '../nominal';
declare enum ScientificPitchNoteName {
    C = "C",
    C_SHARP_D_FLAT = "C_SHARP_D_FLAT",
    D = "D",
    D_SHARP_E_FLAT = "D_SHARP_E_FLAT",
    E = "E",
    F = "F",
    F_SHARP_G_FLAT = "F_SHARP_G_FLAT",
    G = "G",
    G_SHARP_A_FLAT = "G_SHARP_A_FLAT",
    A = "A",
    A_SHARP_B_FLAT = "A_SHARP_B_FLAT",
    B = "B"
}
declare enum ScientificPitchOctaveNumber {
    _NEGATIVE_1 = "_NEGATIVE_1",
    _0 = "_0",
    _1 = "_1",
    _2 = "_2",
    _3 = "_3",
    _4 = "_4",
    _5 = "_5",
    _6 = "_6",
    _7 = "_7",
    _8 = "_8",
    _9 = "_9",
    _10 = "_10"
}
declare type ScientificPitches = {
    [Index in ScientificPitchNoteName]: ObjectOf<Tone>;
};
declare type Value = Delta<Time>;
declare type Pitch = Interval<Frequency>;
declare type Position = Delta<Space>;
declare type Intensity = Scalar<Amplitude>;
declare type Duration = Delta<Ms>;
declare type Tone = Point<Hz>;
declare type Location = Point<Meters>;
declare type Gain = NormalScalar<Amplitude>;
export { ScientificPitchNoteName, ScientificPitchOctaveNumber, ScientificPitches, Value, Pitch, Position, Intensity, Duration, Tone, Location, Gain, };
