import { ArrayedOrStringType, ArrayedType } from './index';
import { Amplitude, Arc, Base, Block, CanBeAsAnUnwholeUseOfNoType, CanBeAsAnUnwholeUseOfSomeType, CanBeAsAWholeUseOfNoType, CanBeAsAWholeUseOfSomeType, CanBeAsAWholeUseWithAnArrayOverloadOfNoType, CanBeAsAWholeUseWithAnArrayOverloadOfSomeType, Cardinal, Cents, ContourElement, ContourPiece, ContourWhole, Cycle, Delta, Denominator, Exponent, Factor, Frequency, Hz, Integer, Interval, Logarithm, Meters, Modulus, Monzo, Ms, Multiple, NoOf, NormalScalar, NoUnits, NoUse, Numerator, Of, Ordinal, Point, Power, Radians, Rational, Remaindee, Rotation, Scalar, Semitones, Space, Time, Transition, Translation, Transposition, Turn, Unwhole, Val } from './types';
declare const number: <RationalOrNumericType extends Number | Rational>(asNumber: RationalOrNumericType) => number;
declare const unbrandedArray: <ElementType, ArrayType extends ArrayedType = ElementType[]>(asArray: ArrayType) => ElementType[];
declare const Hz: <NumericType extends NoUnits>(asHz: NumericType) => Hz;
declare const Ms: <NumericType extends NoUnits>(asMs: NumericType) => Ms;
declare const Meters: <NumericType extends NoUnits>(asMeters: NumericType) => Meters;
declare const Frequency: <NumericType extends NoUnits>(asFrequency: NumericType) => Frequency;
declare const Space: <NumericType extends NoUnits>(asSpace: NumericType) => Space;
declare const Time: <NumericType extends NoUnits>(asTime: NumericType) => Time;
declare const Radians: <NumericType extends NoUnits>(asRadians: NumericType) => Radians;
declare const Cents: <NumericType extends NoUnits>(asCents: NumericType) => Cents;
declare const Semitones: <NumericType extends NoUnits>(asSemitones: NumericType) => Semitones;
declare const Amplitude: <NumericType extends NoUnits>(asAmplitude: NumericType) => Amplitude;
declare const Numerator: <NumericType extends NoUnits>(asNumerator: NumericType) => Numerator;
declare const Denominator: <NumericType extends NoUnits>(asDenominator: NumericType) => Denominator;
declare const Rational: (rational: [Integer | Numerator, Integer | Denominator]) => Rational;
declare const Scalar: {
    <OfType extends CanBeAsAnUnwholeUseOfNoType = number>(asScalar: OfType): Scalar;
    <OfType extends CanBeAsAnUnwholeUseOfSomeType = number>(asScalar: number | Of<OfType>): Scalar<OfType>;
    <OfType extends CanBeAsAnUnwholeUseOfNoType = number>(asScalar: OfType): Scalar;
};
declare const Translation: {
    <OfType extends CanBeAsAnUnwholeUseOfNoType = number>(asTranslation: OfType): Translation;
    <OfType extends CanBeAsAnUnwholeUseOfSomeType = number>(asTranslation: number | Of<OfType>): Translation<OfType>;
    <OfType extends CanBeAsAnUnwholeUseOfNoType = number>(asTranslation: OfType): Translation;
};
declare const Rotation: {
    <OfType extends CanBeAsAnUnwholeUseOfNoType = number>(asRotation: OfType): Rotation;
    <OfType extends CanBeAsAnUnwholeUseOfSomeType = number>(asRotation: number | Of<OfType>): Rotation<OfType>;
    <OfType extends CanBeAsAnUnwholeUseOfNoType = number>(asRotation: OfType): Rotation;
};
declare const Exponent: {
    <OfType extends CanBeAsAnUnwholeUseOfNoType = number>(asExponent: OfType): Exponent;
    <OfType extends CanBeAsAnUnwholeUseOfSomeType = number>(asExponent: number | Of<OfType>): Exponent<OfType>;
    <OfType extends CanBeAsAnUnwholeUseOfNoType = number>(asExponent: OfType): Exponent;
};
declare const Logarithm: {
    <OfType extends CanBeAsAnUnwholeUseOfNoType = number>(asLogarithm: OfType): Logarithm;
    <OfType extends CanBeAsAnUnwholeUseOfSomeType = number>(asLogarithm: number | Of<OfType>): Logarithm<OfType>;
    <OfType extends CanBeAsAnUnwholeUseOfNoType = number>(asLogarithm: OfType): Logarithm;
};
declare const Modulus: {
    <OfType extends CanBeAsAnUnwholeUseOfNoType = number>(asModulus: OfType): Modulus;
    <OfType extends CanBeAsAnUnwholeUseOfSomeType = number>(asModulus: number | Of<OfType>): Modulus<OfType>;
    <OfType extends CanBeAsAnUnwholeUseOfNoType = number>(asModulus: OfType): Modulus;
};
declare const Point: {
    <OfType extends CanBeAsAnUnwholeUseOfNoType & NoUse = number>(asPoint: OfType): Point;
    <OfType extends CanBeAsAnUnwholeUseOfSomeType & NoUse = number>(asPoint: number | Of<OfType>): Point<OfType>;
    <OfType extends CanBeAsAnUnwholeUseOfNoType & NoUse = number>(asPoint: OfType): Point;
};
declare const Interval: {
    <OfType extends CanBeAsAnUnwholeUseOfNoType = number>(asInterval: OfType): Interval;
    <OfType extends CanBeAsAnUnwholeUseOfSomeType = number>(asInterval: number | Of<OfType>): Interval<OfType>;
    <OfType extends CanBeAsAnUnwholeUseOfNoType = number>(asInterval: OfType): Interval;
};
declare const Delta: {
    <OfType extends CanBeAsAnUnwholeUseOfNoType = number>(asDelta: OfType): Delta;
    <OfType extends CanBeAsAnUnwholeUseOfSomeType = number>(asDelta: number | Of<OfType>): Delta<OfType>;
    <OfType extends CanBeAsAnUnwholeUseOfNoType = number>(asDelta: OfType): Delta;
};
declare const Arc: {
    <OfType extends CanBeAsAnUnwholeUseOfNoType = number>(asArc: OfType): Arc;
    <OfType extends CanBeAsAnUnwholeUseOfSomeType = number>(asArc: number | Of<OfType>): Arc<OfType>;
    <OfType extends CanBeAsAnUnwholeUseOfNoType = number>(asArc: OfType): Arc;
};
declare const Multiple: {
    <OfType extends CanBeAsAWholeUseWithAnArrayOverloadOfNoType = number>(asMultiple: OfType): Multiple;
    <OfType extends CanBeAsAWholeUseWithAnArrayOverloadOfSomeType = number>(asMultiple: number | Of<OfType>): Multiple<OfType>;
    <OfType extends CanBeAsAWholeUseWithAnArrayOverloadOfNoType = number>(asMultiple: OfType): Multiple;
};
declare const Cardinal: {
    <OfType extends CanBeAsAWholeUseWithAnArrayOverloadOfNoType = number>(asCardinal: OfType): Cardinal;
    <OfType extends CanBeAsAWholeUseWithAnArrayOverloadOfSomeType = number>(asCardinal: number | Of<OfType>): Cardinal<OfType>;
    <OfType extends CanBeAsAWholeUseWithAnArrayOverloadOfNoType = number>(asCardinal: OfType): Cardinal;
};
declare const Transposition: {
    <OfType extends CanBeAsAWholeUseWithAnArrayOverloadOfNoType = number>(asTransposition: OfType): Transposition;
    <OfType extends CanBeAsAWholeUseWithAnArrayOverloadOfSomeType = number>(asTransposition: number | Of<OfType>): Transposition<OfType>;
    <OfType extends CanBeAsAWholeUseWithAnArrayOverloadOfNoType = number>(asTransposition: OfType): Transposition;
};
declare const Power: {
    <OfType extends CanBeAsAWholeUseOfNoType = number>(asPower: OfType): Power;
    <OfType extends CanBeAsAWholeUseOfSomeType = number>(asPower: number | Of<OfType>): Power<OfType>;
    <OfType extends CanBeAsAWholeUseOfNoType = number>(asPower: OfType): Power;
};
declare const Base: {
    <OfType extends CanBeAsAWholeUseOfNoType = number>(asBase: OfType): Base;
    <OfType extends CanBeAsAWholeUseOfSomeType = number>(asBase: number | Of<OfType>): Base<OfType>;
    <OfType extends CanBeAsAWholeUseOfNoType = number>(asBase: OfType): Base;
};
declare const Remaindee: {
    <OfType extends CanBeAsAWholeUseOfNoType = number>(asRemaindee: OfType): Remaindee;
    <OfType extends CanBeAsAWholeUseOfSomeType = number>(asRemaindee: number | Of<OfType>): Remaindee<OfType>;
    <OfType extends CanBeAsAWholeUseOfNoType = number>(asRemaindee: OfType): Remaindee;
};
declare const Ordinal: {
    <OfType extends NoOf = number>(asOrdinal: OfType): Ordinal;
    <OfType extends ArrayedOrStringType = number[]>(asOrdinal: number | Of<OfType>): Ordinal<OfType>;
    <OfType extends NoOf = number>(asOrdinal: OfType): Ordinal;
};
declare const Factor: {
    <OfType extends NoOf = number>(asFactor: OfType): Factor;
    <OfType extends ArrayedOrStringType = number[]>(asFactor: number | Of<OfType>): Factor<OfType>;
    <OfType extends NoOf = number>(asFactor: OfType): Factor;
};
declare const Transition: {
    <OfType extends NoOf = number>(asTransition: OfType): Transition;
    <OfType extends ArrayedOrStringType = number[]>(asTransition: number | Of<OfType>): Transition<OfType>;
    <OfType extends NoOf = number>(asTransition: OfType): Transition;
};
declare const Turn: {
    <OfType extends NoOf = number>(asTurn: OfType): Turn;
    <OfType extends ArrayedOrStringType = number[]>(asTurn: number | Of<OfType>): Turn<OfType>;
    <OfType extends NoOf = number>(asTurn: OfType): Turn;
};
declare const NormalScalar: {
    <OfType extends Unwhole & NoOf = number>(asNormalScalar: OfType): NormalScalar;
    <OfType extends Unwhole = number>(asNormalScalar: number | Of<OfType>): NormalScalar<OfType>;
    <OfType extends Unwhole & NoOf = number>(asNormalScalar: OfType): NormalScalar;
};
declare const Integer: <OfType extends NoUnits>(asInteger: OfType) => Integer;
declare const Cycle: <ElementType = number, ArrayType extends ArrayedOrStringType<ElementType> = ElementType[]>(asCycle: ArrayType) => Cycle<ElementType>;
declare const Monzo: (asMonzo: Integer[]) => Monzo;
declare const Val: (asVal: Integer[]) => Val;
declare const Block: (asBlock: number[]) => Block;
declare const ContourElement: <ContourType>(asContourElement: number[]) => ContourElement<ContourType>;
declare const ContourPiece: <ContourType>(asContourPiece: Array<number[] | ContourElement<ContourType>>) => ContourPiece<ContourType>;
declare const ContourWhole: <ContourType>(asContourWhole: Array<number[] | ContourElement<ContourType>>) => ContourWhole<ContourType>;
export { Base, Cardinal, Scalar, Translation, Power, Ms, Hz, Radians, Cents, Semitones, Block, Cycle, ContourElement, ContourPiece, ContourWhole, Rational, Numerator, Denominator, Modulus, Rotation, Ordinal, Integer, Meters, Space, Time, Frequency, Amplitude, NormalScalar, Multiple, Exponent, Logarithm, Remaindee, Transposition, Point, Interval, Delta, Arc, Factor, Transition, Turn, number, unbrandedArray, Monzo, Val, };
