import { Brand, NoUnits } from './types';
interface NominalNumber {
    _NominalBrand?: string;
    _UnitsBrand?: Brand | 'NoUnits';
    _UseBrand?: Brand | 'NoUse';
}
declare type DummyValueForComputingNominalInterface = unknown;
interface NominalInterfaceOptionObject {
    number?: any;
    numericArray?: any;
}
declare type CustomAsMono<NominalInterfaceOptionObjectType extends NominalInterfaceOptionObject = NominalInterfaceOptionObject> = {
    [Index in keyof NominalInterfaceOptionObjectType['number']]: <NumericType extends NoUnits>(numeral: NumericType) => NominalInterfaceOptionObjectType['number'][Index];
};
declare type CustomAsPoly<NominalInterfaceOptionObjectType extends NominalInterfaceOptionObject = NominalInterfaceOptionObject> = {
    [Index in keyof NominalInterfaceOptionObjectType['numericArray']]: <NumericElementType extends NoUnits>(value: NumericElementType[]) => NominalInterfaceOptionObjectType['numericArray'][Index];
};
declare type CustomAs<NominalInterfaceOptionObjectType extends NominalInterfaceOptionObject = NominalInterfaceOptionObject> = CustomAsMono<NominalInterfaceOptionObjectType> & CustomAsPoly<NominalInterfaceOptionObjectType>;
interface NominalInterface<NominalInterfaceOptionObjectType extends NominalInterfaceOptionObject = NominalInterfaceOptionObject> {
    as: CustomAs<NominalInterfaceOptionObjectType>;
}
declare const computeNominalInterface: <NominalInterfaceOptionObjectType extends NominalInterfaceOptionObject>(nominalInterfaceOptionsObject: NominalInterfaceOptionObjectType) => NominalInterface<NominalInterfaceOptionObjectType>;
declare const DUMMY_VALUE_FOR_COMPUTING_NOMINAL_INTERFACE: DummyValueForComputingNominalInterface;
export { NominalNumber, DUMMY_VALUE_FOR_COMPUTING_NOMINAL_INTERFACE, computeNominalInterface, NominalInterface, NominalInterfaceOptionObject, CustomAs, };
