import { ObjectDifference } from '../code';
declare type Brand = HzBrand | MsBrand | MetersBrand | FrequencyBrand | TimeBrand | SpaceBrand | RadiansBrand | CentsBrand | SemitonesBrand | AmplitudeBrand | NumeratorBrand | DenominatorBrand | CardinalBrand | TranslationBrand | MultipleBrand | ScalarBrand | TranspositionBrand | RotationBrand | PowerBrand | ExponentBrand | BaseBrand | LogarithmBrand | RemaindeeBrand | ModulusBrand | OrdinalBrand | PointBrand | NormalScalarBrand | NormalBrand | NonNormalBrand | IntegerBrand | NonIntegerBrand;
interface BrandUse {
    _UseBrand: Brand;
}
interface HzBrand {
    _HzBrand: 'Hz';
}
interface MsBrand {
    _MsBrand: 'Ms';
}
interface MetersBrand {
    _MetersBrand: 'Meters';
}
interface FrequencyBrand {
    _FrequencyBrand: 'Frequency';
}
interface TimeBrand {
    _TimeBrand: 'Time';
}
interface SpaceBrand {
    _SpaceBrand: 'Space';
}
interface RadiansBrand {
    _RadiansBrand: 'Radians';
}
interface CentsBrand {
    _CentsBrand: 'Cents';
}
interface SemitonesBrand {
    _SemitonesBrand: 'Semitones';
}
interface AmplitudeBrand {
    _AmplitudeBrand: 'Amplitude';
}
interface NumeratorBrand {
    _NumeratorBrand: 'Numerator';
}
interface DenominatorBrand {
    _DenominatorBrand: 'Denominator';
}
interface CardinalBrand {
    _CardinalBrand: 'Cardinal';
}
interface TranslationBrand {
    _TranslationBrand: 'Translation';
}
interface MultipleBrand {
    _MultipleBrand: 'Multiple';
}
interface ScalarBrand {
    _ScalarBrand: 'Scalar';
}
interface TranspositionBrand {
    _TranspositionBrand: 'Transposition';
}
interface RotationBrand {
    _RotationBrand: 'Rotation';
}
interface PowerBrand {
    _PowerBrand: 'Power';
}
interface ExponentBrand {
    _ExponentBrand: 'Exponent';
}
interface BaseBrand {
    _BaseBrand: 'Base';
}
interface LogarithmBrand {
    _LogarithmBrand: 'Logarithm';
}
interface RemaindeeBrand {
    _RemaindeeBrand: 'Remaindee';
}
interface ModulusBrand {
    _ModulusBrand: 'Modulus';
}
interface OrdinalBrand {
    _OrdinalBrand: 'Ordinal';
}
interface PointBrand {
    _PointBrand: 'Point';
}
interface NormalScalarBrand {
    _NormalScalarBrand: 'NormalScalar';
}
interface NormalBrand {
    _NormalBrand: 'Normal';
}
interface NonNormalBrand {
    _NonNormalBrand: 'NonNormal';
}
interface IntegerBrand {
    _IntegerBrand: 'Integer';
}
interface NonIntegerBrand {
    _NonIntegerBrand: 'NonInteger';
}
declare type NoUnits = Number & {
    _UnitsBrand?: 'NoUnits';
};
declare type UnitsBrand<BrandType> = NoUse & {
    _UnitsBrand: BrandType;
} & MaybeWhole<BrandType>;
declare type Hz = UnitsBrand<HzBrand>;
declare type Ms = UnitsBrand<MsBrand>;
declare type Meters = UnitsBrand<MetersBrand>;
declare type Frequency = UnitsBrand<FrequencyBrand>;
declare type Time = UnitsBrand<TimeBrand>;
declare type Space = UnitsBrand<SpaceBrand>;
declare type Radians = UnitsBrand<RadiansBrand>;
declare type Cents = UnitsBrand<CentsBrand>;
declare type Semitones = UnitsBrand<SemitonesBrand>;
declare type Amplitude = UnitsBrand<AmplitudeBrand>;
declare type Numerator = UnitsBrand<NumeratorBrand>;
declare type Denominator = UnitsBrand<DenominatorBrand>;
declare type Ator = Numerator & Denominator;
declare type Rational = [Numerator, Denominator];
declare type NoUse = Number & {
    _UseBrand?: 'NoUse';
};
declare type UseBrand<BrandType, OfType = number> = UseOf<OfType> & {
    _UseBrand: BrandType;
} & MaybeWhole<BrandType> & MaybeNormal<BrandType>;
declare type UseBrandFromUse<Use> = Use extends Multiple ? MultipleBrand & ScalarBrand : Use extends Cardinal ? CardinalBrand & TranslationBrand : Use extends Transposition ? TranspositionBrand & RotationBrand : Use extends Power ? PowerBrand & ExponentBrand : Use extends Base ? BaseBrand & LogarithmBrand : Use extends Remaindee ? RemaindeeBrand & ModulusBrand : Use extends Ordinal ? OrdinalBrand & PointBrand : Use extends NormalScalar ? NormalScalarBrand & ScalarBrand : Use extends Scalar ? ScalarBrand : Use extends Translation ? TranslationBrand : Use extends Rotation ? RotationBrand : Use extends Exponent ? ExponentBrand : Use extends Logarithm ? LogarithmBrand : Use extends Modulus ? ModulusBrand : Use extends Point ? PointBrand : '';
declare type UseOf<OfType> = Number & {
    _UseOfBrand: OfType;
};
declare type NoOf = number & {
    _OfBrand?: 'NoOf';
};
declare type Of<OfType> = number | {
    _OfBrand: OfType;
};
declare type Scalar<OfType extends CanBeAsAnUnwholeUseOfSomeType = number> = UseBrand<ScalarBrand, OfType>;
declare type Translation<OfType extends CanBeAsAnUnwholeUseOfSomeType = number> = UseBrand<TranslationBrand, OfType>;
declare type Rotation<OfType extends CanBeAsAnUnwholeUseOfSomeType = number> = UseBrand<RotationBrand, OfType>;
declare type Exponent<OfType extends CanBeAsAnUnwholeUseOfSomeType = number> = UseBrand<ExponentBrand, OfType>;
declare type Logarithm<OfType extends CanBeAsAnUnwholeUseOfSomeType = number> = UseBrand<LogarithmBrand, OfType>;
declare type Modulus<OfType extends CanBeAsAnUnwholeUseOfSomeType = number> = UseBrand<ModulusBrand, OfType>;
declare type Point<OfType extends CanBeAsAnUnwholeUseOfSomeType & NoUse = number> = UseBrand<PointBrand, OfType>;
declare type Interval<OfType extends CanBeAsAnUnwholeUseOfSomeType = number> = Scalar<Point<OfType>>;
declare type Delta<OfType extends CanBeAsAnUnwholeUseOfSomeType = number> = Translation<Point<OfType>>;
declare type Arc<OfType extends CanBeAsAnUnwholeUseOfSomeType = number> = Rotation<Point<OfType>>;
declare type Multiple<OfType extends CanBeAsAWholeUseWithAnArrayOverloadOfSomeType = number> = UseBrand<MultipleBrand & ScalarBrand, OfType> & NonNormal;
declare type Cardinal<OfType extends CanBeAsAWholeUseWithAnArrayOverloadOfSomeType = number> = UseBrand<CardinalBrand & TranslationBrand, OfType> & NonNormal;
declare type Transposition<OfType extends CanBeAsAWholeUseWithAnArrayOverloadOfSomeType = number> = UseBrand<TranspositionBrand & RotationBrand, OfType> & NonNormal;
declare type Power<OfType extends CanBeAsAWholeUseOfSomeType = number> = UseBrand<PowerBrand & ExponentBrand, OfType> & NonNormal;
declare type Base<OfType extends CanBeAsAWholeUseOfSomeType = number> = UseBrand<BaseBrand & LogarithmBrand, OfType> & NonNormal;
declare type Remaindee<OfType extends CanBeAsAWholeUseOfSomeType = number> = UseBrand<RemaindeeBrand & ModulusBrand, OfType> & NonNormal;
declare type Ordinal<OfType extends {
    _OfBrand?: 'NoOf';
} & ArrayedOrStringType = number[] & {
    _OfBrand?: 'NoOf';
}> = UseBrand<OrdinalBrand & PointBrand, OfType> & NonNormal;
declare type Factor<OfType extends {
    _OfBrand?: 'NoOf';
} & ArrayedOrStringType = number[] & {
    _OfBrand?: 'NoOf';
}> = Multiple<Ordinal<OfType>>;
declare type Transition<OfType extends {
    _OfBrand?: 'NoOf';
} & ArrayedOrStringType = number[] & {
    _OfBrand?: 'NoOf';
}> = Cardinal<Ordinal<OfType>>;
declare type Turn<OfType extends {
    _OfBrand?: 'NoOf';
} & ArrayedOrStringType = number[] & {
    _OfBrand?: 'NoOf';
}> = Transposition<Ordinal<OfType>>;
declare type MaybeNormal<Name> = Name extends NormalScalarBrand ? Normal : {};
declare type Normal = Number & {
    _NormalBrand: NormalBrand;
};
declare type NonNormal = Number & {
    _NormalBrand?: NonNormalBrand;
};
declare type NormalScalar<OfType extends Unwhole = number> = UseBrand<NormalScalarBrand & ScalarBrand, OfType> & Unwhole;
declare type Integer = number & Whole;
declare type Whole = Number & {
    _IntegerBrand: IntegerBrand;
};
declare type Unwhole = Number & {
    _IntegerBrand?: NonIntegerBrand;
};
declare type UnwholeVersion<NumericType extends Number> = (NumericType extends Whole ? NumericType extends Brand | BrandUse ? WholeToUnwhole<NumericType> & {
    _IntegerBrand: NonIntegerBrand;
} : number & {
    _IntegerBrand: NonIntegerBrand;
} : NumericType);
declare type WholeVersion<NumericType extends Number> = {
    _IntegerBrand: IntegerBrand;
} & (NumericType extends BrandUse ? UnwholeToWhole<NumericType> : NumericType);
declare type UnwholeToWhole<UnwholeType> = UnwholeType extends ScalarBrand ? UnwholeType & MultipleBrand : UnwholeType extends TranslationBrand ? UnwholeType & CardinalBrand : UnwholeType extends RotationBrand ? UnwholeType & TranspositionBrand : UnwholeType extends ExponentBrand ? UnwholeType & PowerBrand : UnwholeType extends LogarithmBrand ? UnwholeType & BaseBrand : UnwholeType extends ModulusBrand ? UnwholeType & RemaindeeBrand : UnwholeType extends PointBrand ? UnwholeType & OrdinalBrand : UnwholeType;
declare type WholeToUnwhole<WholeType> = WholeType extends NumeratorBrand ? number : WholeType extends DenominatorBrand ? number : WholeType extends {
    _UseBrand: MultipleBrand;
} ? ObjectDifference<WholeType, {
    _UseBrand: MultipleBrand;
}> & {
    _UseBrand: ScalarBrand;
} : WholeType extends {
    _UseBrand: CardinalBrand;
} ? ObjectDifference<WholeType, {
    _UseBrand: CardinalBrand;
}> & {
    _UseBrand: TranslationBrand;
} : WholeType extends {
    _UseBrand: TranspositionBrand;
} ? ObjectDifference<WholeType, {
    _UseBrand: TranspositionBrand;
}> & {
    _UseBrand: RotationBrand;
} : WholeType extends {
    _UseBrand: PowerBrand;
} ? ObjectDifference<WholeType, {
    _UseBrand: PowerBrand;
}> & {
    _UseBrand: ExponentBrand;
} : WholeType extends {
    _UseBrand: BaseBrand;
} ? ObjectDifference<WholeType, {
    _UseBrand: BaseBrand;
}> & {
    _UseBrand: LogarithmBrand;
} : WholeType extends {
    _UseBrand: RemaindeeBrand;
} ? ObjectDifference<WholeType, {
    _UseBrand: RemaindeeBrand;
}> & {
    _UseBrand: ModulusBrand;
} : WholeType extends {
    _UseBrand: OrdinalBrand;
} ? ObjectDifference<WholeType, {
    _UseBrand: OrdinalBrand;
}> & {
    _UseBrand: PointBrand;
} : WholeType;
declare type MaybeWhole<Name> = Name extends MultipleBrand ? Whole : Name extends CardinalBrand ? Whole : Name extends TranspositionBrand ? Whole : Name extends PowerBrand ? Whole : Name extends BaseBrand ? Whole : Name extends RemaindeeBrand ? Whole : Name extends OrdinalBrand ? Whole : Name extends NumeratorBrand ? Whole : Name extends DenominatorBrand ? Whole : {};
declare type CanBeAsAWholeUseOfSomeType = NonNormal;
declare type CanBeAsAWholeUseOfNoType = CanBeAsAWholeUseOfSomeType & NoOf;
declare type CanBeAsAnUnwholeUseOfSomeType = CanBeAsAWholeUseOfSomeType & Unwhole;
declare type CanBeAsAnUnwholeUseOfNoType = CanBeAsAWholeUseOfNoType & Unwhole;
declare type ArrayedType<ElementType = unknown> = ElementType[] | Cycle<ElementType>;
declare type ArrayedOrStringType<ElementType = unknown> = ArrayedType<ElementType> | string;
declare type CanBeAsAWholeUseWithAnArrayOverloadOfSomeType = CanBeAsAWholeUseOfSomeType | ArrayedOrStringType;
declare type CanBeAsAWholeUseWithAnArrayOverloadOfNoType = CanBeAsAWholeUseOfNoType | ArrayedOrStringType;
declare type AnyArrayedType = any[] & Cycle<any>;
declare type AnyArrayedOrStringType = AnyArrayedType & string;
declare type Cycle<ElementType = number> = ElementType[] & {
    _CycleBrand: boolean;
};
declare type Monzo = Integer[] & {
    _MonzoBrand: boolean;
};
declare type Val = Integer[] & {
    _ValBrand: boolean;
};
declare type Block = number[] & {
    _BlockBrand: unknown;
};
declare type ContourElement<ContourType> = [number, ...number[]] & {
    length: ContourType;
} & (ContourType extends 1 ? {
    0: number;
} : ContourType extends 2 ? {
    0: number;
    1: number;
} : ContourType extends 3 ? {
    0: number;
    1: number;
    2: number;
} : ContourType extends 4 ? {
    0: number;
    1: number;
    2: number;
    3: number;
} : ContourType extends 5 ? {
    0: number;
    1: number;
    2: number;
    3: number;
    4: number;
} : ContourType extends 6 ? {
    0: number;
    1: number;
    2: number;
    3: number;
    4: number;
    5: number;
} : ContourType extends 7 ? {
    0: number;
    1: number;
    2: number;
    3: number;
    4: number;
    5: number;
    6: number;
} : ContourType extends 8 ? {
    0: number;
    1: number;
    2: number;
    3: number;
    4: number;
    5: number;
    6: number;
    7: number;
} : ContourType extends 9 ? {
    0: number;
    1: number;
    2: number;
    3: number;
    4: number;
    5: number;
    6: number;
    7: number;
    8: number;
} : ContourType extends 10 ? {
    0: number;
    1: number;
    2: number;
    3: number;
    4: number;
    5: number;
    6: number;
    7: number;
    8: number;
    9: number;
} : {
    [index: number]: number;
});
declare type ContourPiece<ContourType> = Array<ContourElement<ContourType>> & {
    _ContourPieceBrand: unknown;
};
declare type ContourWhole<ContourType> = Array<ContourElement<ContourType>> & {
    _ContourWholeBrand: unknown;
};
export { Base, Cardinal, Scalar, Translation, Power, Hz, Ms, Radians, Cents, Semitones, Block, Cycle, ContourElement, ContourPiece, ContourWhole, Rational, Numerator, Denominator, Modulus, Rotation, Ordinal, NoUnits, NoUse, Integer, Meters, Space, Time, Frequency, Amplitude, NormalScalar, UseBrand, UseOf, UnitsBrand, Multiple, Of, UseBrandFromUse, NoOf, Whole, Unwhole, Exponent, Logarithm, Remaindee, NonNormal, UnwholeVersion, WholeVersion, CanBeAsAWholeUseOfNoType, CanBeAsAnUnwholeUseOfNoType, Transposition, Point, CanBeAsAWholeUseOfSomeType, CanBeAsAnUnwholeUseOfSomeType, CanBeAsAWholeUseWithAnArrayOverloadOfNoType, CanBeAsAWholeUseWithAnArrayOverloadOfSomeType, ArrayedOrStringType, AnyArrayedType, Interval, Delta, Arc, Factor, Transition, Turn, ArrayedType, AnyArrayedOrStringType, Monzo, Val, TranslationBrand, PointBrand, ScalarBrand, Ator, Brand, };
