import { Arc, ArrayedType, Base, Cardinal, Cycle, Delta, Denominator, Exponent, Factor, Interval, Logarithm, Modulus, Multiple, NonNormal, NormalScalar, Numerator, Ordinal, Power, Rational, Remaindee, Rotation, Scalar, Transition, Translation, Transposition, Turn, Unwhole } from './types';
declare const Numerator: (numeral: Denominator, useNumerator: Numerator) => Rational;
declare const Denominator: (numeral: Numerator, useDenominator: Denominator) => Rational;
declare const Scalar: <OfType extends Unwhole>(numeral: OfType, useScalar: Scalar<OfType>) => OfType;
declare const Translation: <OfType extends Unwhole>(numeral: OfType, useTranslation: Translation<OfType>) => OfType;
declare const Rotation: <OfType extends Unwhole>(numeral: OfType, useRotation: Rotation<OfType>) => OfType;
declare const Exponent: <OfType extends Unwhole>(numeral: OfType, useExponent: Exponent<OfType>) => OfType;
declare const Logarithm: <OfType extends Unwhole>(numeral: OfType, useLogarithm: Logarithm<OfType>) => OfType;
declare const Modulus: <OfType extends Unwhole>(numeral: OfType, useModulus: Modulus<OfType>) => OfType;
declare const Interval: <OfType extends Unwhole>(numeral: OfType, useInterval: Interval<OfType>) => OfType;
declare const Delta: <OfType extends Unwhole>(numeral: OfType, useDelta: Delta<OfType>) => OfType;
declare const Arc: <OfType extends Unwhole>(numeral: OfType, useArc: Arc<OfType>) => OfType;
declare const Multiple: {
    <OfType extends NonNormal>(numeral: OfType, useMultiple: Multiple<OfType>): OfType;
    <OfType extends ArrayedType>(numeral: OfType, useMultiple: Multiple<OfType>): OfType;
};
declare const Cardinal: {
    <OfType extends NonNormal>(numeral: OfType, useCardinal: Cardinal<OfType>): OfType;
    <OfType extends ArrayedType>(array: OfType, useCardinal: Cardinal<OfType>): OfType;
};
declare const Transposition: {
    <OfType extends NonNormal>(numeral: OfType, useTransposition: Transposition<OfType>): OfType;
    <OfType extends ArrayedType>(numeral: OfType, useTransposition: Transposition<OfType>): OfType;
};
declare const Power: <OfType extends NonNormal>(numeral: OfType, usePower: Power<OfType>) => OfType;
declare const Base: <OfType extends NonNormal>(numeral: OfType, useBase: Base<OfType>) => OfType;
declare const Remaindee: <OfType extends NonNormal>(numeral: OfType, useRemaindee: Remaindee<OfType>) => OfType;
declare const Ordinal: <ElementType>(array: ArrayedType<ElementType>, useOrdinal: Ordinal<ArrayedType<ElementType>>) => ElementType;
declare const Factor: {
    <ElementType>(numeral: Ordinal<Cycle<ElementType>>, useFactor: Factor<Cycle<ElementType>>): Ordinal<Cycle<ElementType>>;
    <ElementType>(numeral: Ordinal<ElementType[]>, useFactor: Factor<ElementType[]>): Ordinal<ElementType[]>;
};
declare const Transition: {
    <ElementType>(numeral: Ordinal<Cycle<ElementType>>, useTransition: Transition<Cycle<ElementType>>): Ordinal<Cycle<ElementType>>;
    <ElementType>(numeral: Ordinal<ElementType[]>, useTransition: Transition<ElementType[]>): Ordinal<ElementType[]>;
};
declare const Turn: {
    <ElementType>(numeral: Ordinal<Cycle<ElementType>>, useFactor: Turn<Cycle<ElementType>>): Ordinal<Cycle<ElementType>>;
    <ElementType>(numeral: Ordinal<ElementType[]>, useFactor: Turn<ElementType[]>): Ordinal<ElementType[]>;
};
declare const NormalScalar: <OfType extends Number>(numeral: OfType, useNormalScalar: NormalScalar<OfType>) => OfType;
export { Cardinal, Base, Translation, Power, Scalar, Ordinal, Modulus, Numerator, Denominator, NormalScalar, Multiple, Rotation, Exponent, Logarithm, Remaindee, Transposition, Interval, Delta, Arc, Factor, Transition, Turn, };
